/*
 * Copyright 2011 Apaq.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package dk.apaq.framework.criteria.jpa;

import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.persistence.FlushModeType;
import javax.persistence.LockModeType;
import javax.persistence.Parameter;
import javax.persistence.Query;
import javax.persistence.TemporalType;

/**
 *
 */
public class MockQuery implements Query{

    private final MockEntityManager entityManager;
    private final String statement;
    private int maxResults=-1;
    private int startPosition = 0;
    private Map<String, Object> params = new HashMap<String, Object>();

    public MockQuery(MockEntityManager entityManager, String statement) {
        this.entityManager = entityManager;
        this.statement = statement;
    }

    public String getStatement() {
        return statement;
    }

    public List getResultList() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Object getSingleResult() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public int executeUpdate() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setMaxResults(int maxResult) {
        this.maxResults = maxResult;
        return this;
    }

    public Query setFirstResult(int startPosition) {
        this.startPosition = startPosition;
        return this;
    }

    public Query setHint(String hintName, Object value) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setParameter(String name, Object value) {
        params.put(name, value);
        return this;
    }

    public Query setParameter(String name, Date value, TemporalType temporalType) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setParameter(String name, Calendar value, TemporalType temporalType) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setParameter(int position, Object value) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setParameter(int position, Date value, TemporalType temporalType) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setParameter(int position, Calendar value, TemporalType temporalType) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setFlushMode(FlushModeType flushMode) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public int getMaxResults() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public int getFirstResult() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Map<String, Object> getHints() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public <T> Query setParameter(Parameter<T> param, T value) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setParameter(Parameter<Calendar> param, Calendar value, TemporalType temporalType) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setParameter(Parameter<Date> param, Date value, TemporalType temporalType) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Set<Parameter<?>> getParameters() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Parameter<?> getParameter(String name) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public <T> Parameter<T> getParameter(String name, Class<T> type) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Parameter<?> getParameter(int position) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public <T> Parameter<T> getParameter(int position, Class<T> type) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public boolean isBound(Parameter<?> param) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public <T> T getParameterValue(Parameter<T> param) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Object getParameterValue(String name) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Object getParameterValue(int position) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public FlushModeType getFlushMode() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Query setLockMode(LockModeType lockMode) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public LockModeType getLockMode() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public <T> T unwrap(Class<T> cls) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

}
