package dk.apaq.framework.criteria;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Person {

    String name;
    int age;
    double height;
    boolean male;
    List<String> nickNames = new ArrayList<String>();

    public Person(String name, int age, double height, boolean male, String ... nickNames) {
        this.name = name;
        this.age = age;
        this.height = height;
        this.male = male;
        
        this.nickNames.addAll(Arrays.asList(nickNames));
    }

    public double getHeight() {
        return height;
    }

    public String getName() {
        return name;
    }

    public int getAge() {
        return age;
    }

    public boolean isMale() {
        return male;
    }

    public List<String> getNickNames() {
        return nickNames;
    }
    
    
}
