package dk.apaq.framework.repository.jdbc.sql;

import org.springframework.data.domain.Pageable;

/**
 * Javadoc
 */
public class PostgreSqlGenerator extends SqlGenerator {

    @Override
    protected String limitClause(Pageable page) {
        final int offset = page.getPageNumber() * page.getPageSize();
        return " LIMIT " + page.getPageSize() + " OFFSET " + offset;
    }
}