package dk.apaq.framework.common.beans.finance;

/**
 *
 * @author krog
 */
public enum PaymentInstrument {
    //CHECKSTYLE:OFF
    American_Express(PaymentType.CreditCard), 
    Dankort(PaymentType.CreditCard), 
    Diners(PaymentType.CreditCard), 
    Jcb(PaymentType.CreditCard), 
    Mastercard(PaymentType.CreditCard), 
    Visa(PaymentType.CreditCard), 
    Visa_Electron(PaymentType.CreditCard), 
    Money(PaymentType.Cash), 
    Unknown(PaymentType.Unknown);
    //CHECKSTYLE:ON

    private PaymentType instrument;

    private PaymentInstrument(PaymentType instrument) {
        this.instrument = instrument;
    }

    /**
     * Retrieves the type of payment this instrument is.
     * @return The type of payment.
     */
    public PaymentType getType() {
        return instrument;
    }
    
}
