package dk.apaq.framework.common.beans.finance;

import static junit.framework.Assert.assertEquals;
import junit.framework.TestCase;
import org.jasypt.encryption.StringEncryptor;
import org.jasypt.encryption.pbe.StandardPBEStringEncryptor;

/**
 *
 * @author krog
 */
public class CardTest extends TestCase {
    
    

    /**
     * Test of getCardHolder method, of class Card.
     */
    public void testBeanPattern() {
        StandardPBEStringEncryptor encryptor = new StandardPBEStringEncryptor();
        encryptor.setPassword("qwerty");
        
        Card instance = new Card("Michael Krog", "4571 1111 1111 1234", 2014, 11, "123", encryptor);
        
        assertEquals("Michael Krog", instance.getCardHolder());
        assertEquals("**** **** **** 1234", instance.getCardNumber());
        assertEquals("4571111111111234", instance.getCardNumber(encryptor));
        assertEquals("123", instance.getCvd(encryptor));
        
    }

    
}
