package dk.apaq.framework.criteria.simplequery.interpreters;

import dk.apaq.framework.criteria.rules.LikeRule;


/**
 * Interpreter for Like rule.
 */
public class LikeRuleInterpreter implements Interpreter<LikeRule> {

    private static final char ESCAPECHAR = '!';

    public boolean interpret(StringBuilder query, LikeRule rule) {
        if (rule.getValue() == null) {
            return false;
        }

        String searchString = rule.getValue();

        query.append(rule.getPropertyId());
        query.append(" LIKE ");
        query.append("\"").append(searchString).append("\"");
    
        return true;
    }
}
