/*
 * Apaq Framework
 * Copyright (C) 2011 by Apaq
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package dk.apaq.framework.criteria.rules;

import dk.apaq.framework.criteria.SpecificRule;



/**
 *
 */
public abstract class AbstractSpecificRule implements SpecificRule {

    private final String propertyId;

    public AbstractSpecificRule(String propertyId) {
        this.propertyId = propertyId;
    }

    @Override
    public String getPropertyId() {
        return propertyId;
    }

    
}
