package dk.apaq.framework.repository;

import java.io.Serializable;
import dk.apaq.framework.criteria.Criteria;
import java.util.List;

import org.springframework.data.repository.CrudRepository;

/**
 *
 * @author michael
 */
public interface Repository<BeanType, IdType extends Serializable> extends CrudRepository<BeanType, IdType> {
    
    BeanType findOne(Criteria criteria);
    
    Iterable<BeanType> findAll(Criteria criteria);
    
    public long count(Criteria criteria);
}
